#include "StdInc.h"
#include "Combos.h"

// Defines
// Structs 
typedef struct _tagCombosMemberVars
{
	Int32 lPos;
	Char **pList;
	Int16 iList;
	Char szComboText [32];
	ComboStringFuncType *pStringFunc;
} CombosMemberVars;
typedef CombosMemberVars *CombosMemberVarsPtr;

// Vars
CombosMemberVarsPtr g_pCombosMemberVars;

// Funcs
Boolean CombosProc(EventPtr pEvent);
void DrawCombos (FormPtr pForm);

void ComboFuncType (Int16 iItem, RectangleType *pRect, Char **pItemText)
{
	g_pCombosMemberVars->pStringFunc(iItem, g_pCombosMemberVars->szComboText);
	DrawCharacters(g_pCombosMemberVars->szComboText, StrLen(g_pCombosMemberVars->szComboText), pRect, DC_LEFT, true);
}

UInt16 DoCombosModal (Char *pTitle, UInt32 *pPos, Char **pList, Int16 iList, ComboStringFuncType *pStringFunc)
{
	FormPtr pForm, pOldForm;
	UInt16 wResult;
	Char *pOldTitle;

	wResult = 0;
	pOldForm = FrmGetActiveForm();
	if (pForm = FrmInitForm(IDF_COMBOS))
	{
		// Pre form stuff.
		FrmSetActiveForm(pForm);
		FrmDrawForm(pForm);

		// Do the every time initialization 
		//  of the Sound Combos here.
		g_pCombosMemberVars = MemPtrNew(sizeof(CombosMemberVars));
		if (g_pCombosMemberVars)
		{
			// Set the members vars;
			g_pCombosMemberVars->lPos = *pPos;
			g_pCombosMemberVars->pList = pList;
			g_pCombosMemberVars->iList = iList;
			g_pCombosMemberVars->pStringFunc = pStringFunc;

			InitDynamicPopup(pForm, IDC_CUSTOM_TYPE, IDC_CUSTOM_LIST, g_pCombosMemberVars->lPos, 
				g_pCombosMemberVars->pList, g_pCombosMemberVars->iList);

			if (g_pCombosMemberVars->pStringFunc != 0)
			{
				ListPtr pList;
	
				// Setup the list function.
				pList = FrmGetObjectPtr(pForm, FrmGetObjectIndex(pForm, IDC_CUSTOM_LIST));
				LstSetDrawFunction(pList, ComboFuncType);
			}

			// Do the Combos.
			DrawCombos(pForm);

			if (pTitle)
			{
				pOldTitle = (Char*)FrmGetTitle(pForm);
				FrmSetTitle(pForm, pTitle);
			}

			// Show the Combos.
			FrmSetEventHandler(pForm, (FormEventHandlerPtr) CombosProc);
			wResult = FrmDoDialog(pForm);

			if (pTitle)
				FrmSetTitle(pForm, pOldTitle);

			if (wResult == IDC_OK)
			{
				// If we didn't change the value pretend we canceled.
				if (g_pCombosMemberVars->lPos != *pPos)
				{
					*pPos = g_pCombosMemberVars->lPos;
				}
				else
				{
					wResult = IDC_CANCEL;
				}
			}
			MemPtrFree(g_pCombosMemberVars);
		}

		// We now return to our other window.
		if (pOldForm)
			FrmSetActiveForm(pOldForm);
		FrmDeleteForm(pForm);
	}

	return wResult;
}

Boolean CombosProc(EventPtr pEvent)
{
	FormPtr pForm = FrmGetActiveForm();
	Boolean bHandled = false;

    switch (pEvent->eType) 
    {
	case ctlSelectEvent:  // A control button was pressed and released.
	{
		switch (pEvent->data.ctlEnter.controlID)
		{
		case IDC_CANCEL:
			bHandled = false;
			break;
		case IDC_OK:
			bHandled = false;
			break;
		default:;
		}
		break;
	}

	case popSelectEvent:
	{
		switch(pEvent->data.popSelect.listID)
		{
        case IDC_CUSTOM_LIST:
            g_pCombosMemberVars->lPos = pEvent->data.popSelect.selection;
			if (g_pCombosMemberVars->pStringFunc != 0)
			{
				DrawCombos(pForm);
				bHandled = true;
			}
            break;
		}
		break;
	}

	default:
		bHandled = false;
	}

	return bHandled;
}

void DrawCombos (FormPtr pForm)
{
	if (g_pCombosMemberVars->pStringFunc != 0)
	{
		ControlPtr pTrigger;
		ListPtr pList;

		// Setup the list function.
		pTrigger = FrmGetObjectPtr(pForm, FrmGetObjectIndex(pForm, IDC_CUSTOM_TYPE));
		pList = FrmGetObjectPtr(pForm, FrmGetObjectIndex(pForm, IDC_CUSTOM_LIST));

		g_pCombosMemberVars->pStringFunc(LstGetSelection(pList), g_pCombosMemberVars->szComboText);
		CtlSetLabel(pTrigger, g_pCombosMemberVars->szComboText);
	}
}
