#ifndef __DATABSEINFO_H
#define __DATABSEINFO_H		1

#ifdef __cplusplus
extern "C" {
#endif

#include "DatabaseCommon.h"

#define RECORDID_NONE		0xffffffff
#define RECORDID_INDEX		0x00000000

typedef struct _tagDataInfo
{
	MemHandle hRecord;
	MemPtr pRecord;
	UInt16 vLength;
	UInt16 vOffset;
} DataInfo;
typedef DataInfo *DataInfoPtr;

typedef struct _tagRecordInfo
{
	DmOpenRef hDatabase;
	UInt32 vId;
	UInt32 vSubId;
	UInt16 vIndex;
	DataInfo vDatabase;
	DataInfo vInput;
} RecordInfo;
typedef RecordInfo *RecordInfoPtr;

Boolean InitializeRecordInfo (RecordInfoPtr pRecordInfo);

Boolean CreateDatabaseRecordInfo (RecordInfoPtr pRecordInfo, UInt32 ulAppId, UInt32 ulDatabaseId);
Boolean OpenDatabaseRecordInfo (RecordInfoPtr pRecordInfo, UInt32 ulAppId, UInt32 ulDatabaseId);
Boolean CloseDatabaseRecordInfo (RecordInfoPtr pRecordInfo);
Boolean DeleteDatabaseRecordInfo (UInt32 ulAppId, UInt32 ulDatabaseId);

Boolean SetAttributesDatabaseRecordInfo (RecordInfoPtr pRecordInfo, UInt16 uAttributes, DbAttribType eDbAttribType);
Boolean SetNameDatabaseRecordInfo (RecordInfoPtr pRecordInfo, Char *pName);
Boolean ChangeIdRecordInfo (RecordInfoPtr pRecordInfo, Int32 lNewId, Int32 lNewSubId);

Boolean ReadRecordInfo (RecordInfoPtr pRecordInfo);
Boolean WriteRecordInfo (RecordInfoPtr pRecordInfo);
Boolean InsertRecordInfo (RecordInfoPtr pRecordInfo);
Boolean OverwriteRecordInfo (RecordInfoPtr pRecordInfo);
Boolean CloseRecordInfo (RecordInfoPtr pRecordInfo);
Boolean DeleteRecordInfo (RecordInfoPtr pRecordInfo);
UInt16 GetCountRecordInfo (RecordInfoPtr pRecordInfo);

Int16 RecordInfoSort (void *pRecord1, void *pRecord2, Int16 iOther, SortRecordInfoPtr pSortInfo1, SortRecordInfoPtr pSortInfo2, MemHandle hAppInfo);

#ifdef __cplusplus
}
#endif

#endif
