#ifndef __MISC_H
#define __MISC_H        1

#ifdef __cplusplus
extern "C" {
#endif

// DrawCharacters type
#define DC_LEFT			0
#define DC_CENTER		1
#define DC_RIGHT		2

// OS version numbers.
#define VERSION_100		sysMakeROMVersion(1,0,0,sysROMStageRelease,0)
#define VERSION_200		sysMakeROMVersion(2,0,0,sysROMStageRelease,0)
#define VERSION_300		sysMakeROMVersion(3,0,0,sysROMStageRelease,0)
#define VERSION_310		sysMakeROMVersion(3,1,0,sysROMStageRelease,0)
#define VERSION_320		sysMakeROMVersion(3,2,0,sysROMStageRelease,0)
#define VERSION_350		sysMakeROMVersion(3,5,0,sysROMStageRelease,0)
#define VERSION_400		sysMakeROMVersion(4,0,0,sysROMStageRelease,0)

typedef FormGadgetType *GadgetPtr;
typedef float Float;

Char *StrLToA (Char *lpStr, Int32 lNum);
Char *StrLToAComma (Char *lpStr, Int32 lNum);
Int32 StrAToL (Char *lpStr);
Int32 StrAToLComma (Char *lpStr);
Int16 MemCompare (Char *ptr1, Char *ptr2, Int16 iCount);

Char *StrRev (Char *pStr);
void QShuffle (UInt8 *base, Int16 numOfElements, Int16 width);

void InitPopup (FormPtr pForm, UInt16 wTriggerId, UInt16 wListId, Int16 iCurrent);
void InitDynamicPopup (FormPtr pForm, UInt16 wTriggerId, UInt16 wListId, Int16 iCurrent, Char **pItems, Int16 iSize);

MemHandle SetField (FormPtr pForm, UInt16 wFieldId, UInt32 ulMaxChars, Char *cpText);
void DrawCharacters (Char *chars, UInt16 len, RectanglePtr r, UInt8 type, Boolean show);

void SetCheck (FormPtr pForm, UInt16 wFieldId, Boolean bCheckState);
Boolean GetCheck (FormPtr pForm, UInt16 wFieldId);

void SetPushButton (FormPtr pForm, UInt16 wStartFieldId, UInt16 wEndFieldId, UInt16 wFieldId);
UInt16 GetPushButton (FormPtr pForm, UInt16 wStartFieldId, UInt16 wEndFieldId);

inline void InflateRect (RectanglePtr pRect, Int16 x, Int16 y);

inline void AutoShiftField (FormPtr pForm, UInt16 wId, Boolean bAutoShift);

Boolean IsRomVersion (UInt32 vVersion);

inline void RefreshForm ();

#ifdef __cplusplus
}
#endif

#endif
