#ifndef __ROLLEM_H
#define __ROLLEM_H      1

#ifdef __cplusplus
extern "C" {
#endif

//#define _DEBUG

#define ROLLEM_ID_APP			'RlEm'
#define ROLLEM_DB_DATA			'Data'
#define ROLLEM_DB_ROLL			'Roll'

#define RECORDID_PREFS			'Pref'
#define RECORDID_SOUNDS			'Snds'
#define RECORDID_RESULTS		'Rslt'
#define RECORDID_PAGES			'Page'
#define RECORDID_ROLLS			'Roll'
#define RECORDID_DISPLAYS		'Disp'

#define MIN_DIE                 2
#define MAX_DIE                 1000
#define MIN_NUMBER              1
#define MAX_NUMBER              1000
#define MIN_MODIFIER           -9999
#define MAX_MODIFIER            10000
#define MIN_BEST                0
#define MAX_BEST                (MAX_NUMBER-1)
#define MIN_COMPARE             0
#define MAX_COMPARE             1000000
#define MIN_SUCCESS             0
#define MAX_SUCCESS             1000

#define MIN_PAGES               1
#define MAX_PAGES               99

#define MIN_ROLLS_SAVED			1
#define MAX_ROLLS_SAVED			100

#define MAX_TITLE_LEN           15
#define MAX_FIELDS				25
#define MAX_DIE_LEN             4
#define MAX_NUMBER_LEN          4
#define MAX_MODIFIER_LEN        6
#define MAX_BEST_LEN            3
#define MAX_ROLLS_LEN			3
#define MAX_COMPARE_LEN         7
#define MAX_SUCCESS_LEN         7
#define MAX_TEMPSTRING_LEN		64
#define MAX_DISPLAY_TITLE		16

#define VERSION_NUMBER			200
#define INIT_PAGES				5
#define INIT_ROLL_SESSION		1
#define INIT_ROLL_NUMBER		8
#define INIT_ADV_CUSTOM			0

#define IDC_BUTTON_FIRST        DisplayItemButton0
#define IDC_BUTTON_LAST         DisplayItemButton7
#define NUM_BUTTONS             ((IDC_BUTTON_LAST - IDC_BUTTON_FIRST) + 1)
#define ID2NUM(wId)             (wId - IDC_BUTTON_FIRST)

// MAX_FIELDS fields

#define NORMAL_DIE				0
#define NORMAL_NUMBER			1
#define NORMAL_MODIFIER			2
#define NORMAL_BEST				3

#define COMMON_BEEPTYPE1		4
#define COMMON_BEEPCOMPARE1		6
#define COMMON_BEEPVALUE1		9
#define COMMON_BEEPTYPE2		5
#define COMMON_BEEPCOMPARE2		7
#define COMMON_BEEPVALUE2		10
#define COMMON_BEEPTYPE3		11
#define COMMON_BEEPCOMPARE3		12
#define COMMON_BEEPVALUE3		13
#define COMMON_ROLLTYPE			14

#define SUCCESS_DIE				15
#define SUCCESS_NUMBER			16
#define SUCCESS_MODIFIER		17
#define SUCCESS_BEST			18
#define SUCCESS_COMPARE			19
#define SUCCESS_VALUE			20

#define THACO_DIE				15
#define THACO_NUMBER			16
#define THACO_MODIFIER			17
#define THACO_VALUE				18

#define OPENEND_DIE				15
#define OPENEND_HIGHCOMPARE		16
#define OPENEND_HIGHVALUE		17
#define OPENEND_LOWCOMPARE		18
#define OPENEND_LOWVALUE		19
#define OPENEND_MAXROLLS		20
#define OPENEND_MODIFIER		21

#define ADDITIVE_DIE1			15
#define ADDITIVE_NUMBER1		16
#define ADDITIVE_DIE2			17
#define ADDITIVE_NUMBER2		18
#define ADDITIVE_MODIFIER		19

#define NOTE_A					440
#define NOTE_B					491
#define NOTE_C					527
#define NOTE_D					589
#define NOTE_E					658
#define NOTE_F					706
#define NOTE_G					788

#define PREVIEW_OFFSET_X		17
#define PREVIEW_OFFSET_Y		20
#define PREVIEW_WIDTH			5
#define PREVIEW_HEIGHT			5
#define DISPLAY_OFFSET_X		5
#define DISPLAY_OFFSET_Y		17
#define DISPLAY_WIDTH			6
#define DISPLAY_HEIGHT			6

// ************************************************************* //
//                         Enumerations                          //
// ************************************************************* //

typedef enum 
{
    ComparisonEqual=0,
    ComparisonGreater,
    ComparisonLess,
    ComparisonGreaterEqual,
    ComparisonLessEqual,
    ComparisonNotEqual
} Comparison;

typedef enum 
{
    DataTypeNumber=0,
    DataTypeString,
	DataTypeCheck,
    DataTypeCompare,
    DataTypeSound,
	DataTypeRollType,
	DataTypeRollLabel,
	DataTypeEnd=255
} DataType;

typedef enum 
{
    RollDisplayNameTitle=0,
    RollDisplayNameRoll,
} RollDisplayName;

typedef enum 
{
	RollDisplayStatSubtotal=0,
    RollDisplayStatTotal,
    RollDisplayStatSum,
    RollDisplayStatMean,
	RollDisplayStatMedian,
    RollDisplayStatMode,
} RollDisplayStat;

typedef enum 
{
	DisplayItemButtonRolls=0,	// 00
    DisplayItemButtonClear,		// 01
    DisplayItemButton0,			// 02
    DisplayItemButton1,			// 03
    DisplayItemButton2,			// 04
    DisplayItemButton3,			// 05
    DisplayItemButton4,			// 06
    DisplayItemButton5,			// 07
    DisplayItemButton6,			// 08
    DisplayItemButton7,			// 09
	DisplayItemButtonPrev,		// 0a
    DisplayItemButtonNext,		// 0b
    DisplayItemButtonPage,		// 0c
    DisplayItemButtonCustom,	// 0d
    DisplayItemRollType,		// 0e
    DisplayItemRollTotal,		// 0f
    DisplayItemRollSum,			// 10
    DisplayItemRollMean,		// 11
    DisplayItemRollMedian,		// 12
    DisplayItemRollMode,		// 13
    DisplayItemRollSubRolls,	// 14
    DisplayItemRollSubDice,		// 15
    DisplayItemRollSubTotal,	// 16
} DisplayItem;

// ************************************************************* //
//                          Structures                           //
// ************************************************************* //

typedef struct _tagDieRoll
{
	Char szTitle [MAX_TITLE_LEN+1];
	Int32 lField [MAX_FIELDS];
} DieRoll;
typedef DieRoll *DieRollPtr;

typedef struct _tagDieRollStat
{
	Int32 lSize;
	Int32 lTotalSize;
	Int32 lTotal;
	Int32 lSum;
	Int32 lMean;
	Int32 lMedian;
	Int32 lMode;
	Int32 lReserved8;
	Int32 lReserved9;
	Int32 lReserved10;
} DieRollStat;
typedef DieRollStat *DieRollStatPtr;

typedef struct _tagNote
{
    UInt16 uiHertz;
    UInt16 uiDuration;
} Note;
typedef Note *NotePtr;
typedef NotePtr *NoteArray;

typedef struct _tagNoteNode
{
	Note vNote;
	MemPtr pNext;
} NoteNode;
typedef NoteNode *NoteNodePtr;

// Prefs
typedef struct _tagPrefs
{
    UInt16 wVersion;
    UInt16 wTotalPages:8;
	UInt16 wSaveRollNumber:8;
	UInt16 wDeleteOnExit:1;
	UInt16 wAdvCustom:1;
	UInt16 wReserved:14;
	UInt16 wRollDisplayName;
	UInt16 wRollDisplayStat;
} Prefs;
typedef Prefs *PrefsPtr;

// Results
typedef struct _tagResults
{
    UInt16 wCurrentPage;
    UInt16 wCurrentButton;
	DieRollStat vLastRollStat;
} Results;
typedef Results *ResultsPtr;

typedef struct _tagSound
{
	Char szTitle [MAX_TITLE_LEN + 1];
	StackNode vNotes;
} Sound;
typedef Sound *SoundPtr;

typedef struct _tagVariable
{
	Char szFieldName [MAX_TITLE_LEN+1];
    UInt16 vDataType:8;
    UInt16 vDataPos:8;
	Int32 lDefault;
	Int32 lMin;
	Int32 lMax;
} Variable;

typedef struct _tagVariableNode
{
	Char *pFieldName;
	Variable *pVariable;
} VariableNode;

// ************************************************************* //
//                           Externs                             //
// ************************************************************* //

extern PrefsPtr g_pPrefs;
extern RecordInfo g_vDataRecordInfo;

// ************************************************************* //
//                     Forward Declarations                      //
// ************************************************************* //

Boolean CheckValue (UInt8 iCompareType, Int32 lCompareValue, Int32 lResult);

#ifdef __cplusplus
}
#endif

#endif
