#include "StdInc.h"
#include "RollEm.h"

#define TEXT_X			8
#define TEXT_Y			20
#define TEXT_WIDTH		136
#define TEXT_HEIGHT		110
#define TEXT_SPACING	2

// Structs 
typedef struct _tagRollSetMemberVars
{
	Int16 g_iSetRowListPos;
	Int16 g_iSetRowListRows;
	Int16 g_iSetRowListCols;
	Int16 g_iResultRowCurrentSize;
	RecordInfo g_vRecordInfo;
} RollSetMemberVars;
typedef RollSetMemberVars *RollSetMemberVarsPtr;

// Vars
RollSetMemberVarsPtr g_pRollSetMemberVars;

Boolean RollSetProc (EventPtr pEvent);
void DrawRollSet ();

void InitSetRowList ();
void DrawSetRowList ();
void MoveSetRowList (Int16 iDirection);

UInt16 DoModalRollSet (Int16 iDisplaySet)
{
	FormPtr pForm, pOldForm;
	UInt16 wResult;

	wResult = 0;
	pOldForm = FrmGetActiveForm();
	if (pForm = FrmInitForm(IDF_SETS))
	{
		// Pre form stuff.
		FrmSetActiveForm(pForm);
		FrmDrawForm(pForm);

		// Do the every time initialization 
		//  of the Sound dialog here.
		g_pRollSetMemberVars = MemPtrNew(sizeof(RollSetMemberVars));
		if (g_pRollSetMemberVars)
		{
			if (OpenDatabaseRecordInfo(&g_pRollSetMemberVars->g_vRecordInfo, ROLLEM_ID_APP, ROLLEM_DB_ROLL) == true)
			{
				// Use the index for saving rolls.
				g_pRollSetMemberVars->g_vRecordInfo.vId = RECORDID_INDEX;
				g_pRollSetMemberVars->g_vRecordInfo.vSubId = RECORDID_INDEX;
				g_pRollSetMemberVars->g_vRecordInfo.vIndex = iDisplaySet;
				if (ReadRecordInfo(&g_pRollSetMemberVars->g_vRecordInfo) == true)
				{
					// Do the RollSet.
					InitSetRowList();
					DrawRollSet();

					// Show the dialog.
					FrmSetEventHandler(pForm, (FormEventHandlerPtr)RollSetProc);
					wResult = FrmDoDialog(pForm);

					// Close the reocrd.
					CloseRecordInfo(&g_pRollSetMemberVars->g_vRecordInfo);
				}

				// Close the database after wa are through with it.
				CloseDatabaseRecordInfo(&g_pRollSetMemberVars->g_vRecordInfo);
			}

			MemPtrFree(g_pRollSetMemberVars);
		}

		// We now return to our other window.
		if (pOldForm)
			FrmSetActiveForm(pOldForm);
		FrmDeleteForm(pForm);
	}

	return wResult;
}

void DrawRollSet ()
{
	DrawSetRowList();
}

Boolean RollSetProc (EventPtr pEvent)
{
    FormPtr pForm = FrmGetActiveForm();
    Boolean bHandled = false;

    switch (pEvent->eType) 
    {
	case frmUpdateEvent:
	{
		FrmDrawForm(pForm);
		DrawRollSet();
		bHandled = true;
		break;
	}

    case sclRepeatEvent:
	{
		MoveSetRowList(pEvent->data.sclRepeat.newValue - pEvent->data.sclRepeat.value);
		break;
	}
	
	case keyDownEvent:
	{
        switch (pEvent->data.keyDown.chr)
        {
        case pageUpChr:
            MoveSetRowList(-1);
            break;
        case pageDownChr:
            MoveSetRowList(1);
            break;
        }
        break;
	}
	}

    return bHandled;
}

void InitSetRowList ()
{
	DieRollStatPtr pDieRollStat;

	pDieRollStat = (DieRollStatPtr)(((Char*)g_pRollSetMemberVars->g_vRecordInfo.vDatabase.pRecord) + sizeof(DieRoll));

	// Modify the lists to look better.
//	SortList();
//	ReverseList();

	g_pRollSetMemberVars->g_iSetRowListPos = 0;
	g_pRollSetMemberVars->g_iSetRowListRows = (TEXT_HEIGHT - (TEXT_SPACING*0)) / FntCharHeight();
	g_pRollSetMemberVars->g_iSetRowListCols = 1;
	g_pRollSetMemberVars->g_iResultRowCurrentSize = pDieRollStat->lSize;

	MoveSetRowList(0);
}

void DrawSetRowList ()
{
    Int16 iCurrentX=TEXT_X + TEXT_SPACING, iCurrentY=TEXT_Y, i;
    Int16 iCharHeight, iListSize, iEnd;
	Int32 lValue;
    Char szText [50];
    RectangleType rtRect;
	Int16 *pValue;

    iCharHeight = FntCharHeight();
	iListSize = g_pRollSetMemberVars->g_iResultRowCurrentSize;

	// Figure out the ending point.
	iEnd = g_pRollSetMemberVars->g_iSetRowListPos + g_pRollSetMemberVars->g_iSetRowListRows;
	if (iEnd > iListSize)
		iEnd = iListSize;

    rtRect.topLeft.x = TEXT_X;
    rtRect.topLeft.y = TEXT_Y;
    rtRect.extent.x = TEXT_WIDTH;
    rtRect.extent.y = TEXT_HEIGHT;

//	WinDrawRectangleFrame(rectangleFrame, &rtRect);

    rtRect.topLeft.x++;
    rtRect.topLeft.y++;
    rtRect.extent.x -= 2;
    rtRect.extent.y -= 2;

	WinEraseRectangle(&rtRect, 0);

	pValue = (Int16*)(((Char*)g_pRollSetMemberVars->g_vRecordInfo.vDatabase.pRecord) + sizeof(DieRoll) + sizeof(DieRollStat));
	pValue += g_pRollSetMemberVars->g_iSetRowListPos;

    for (i=g_pRollSetMemberVars->g_iSetRowListPos; i<iEnd; i++)
    {
		StrLToA(szText, *pValue);
		WinDrawChars(szText, StrLen(szText), iCurrentX, iCurrentY);
		iCurrentY += iCharHeight;
		pValue++;
    }
}

void MoveSetRowList (Int16 iDirection)
{
	FormPtr pForm = FrmGetActiveForm();
	ScrollBarPtr pScroll;
	Int16 iNewPos, iScrollSize;

	if (iDirection != 0)
	{
		iNewPos = g_pRollSetMemberVars->g_iSetRowListPos + iDirection;

		if ((iNewPos + g_pRollSetMemberVars->g_iSetRowListRows) > g_pRollSetMemberVars->g_iResultRowCurrentSize)
			iNewPos = g_pRollSetMemberVars->g_iResultRowCurrentSize - g_pRollSetMemberVars->g_iSetRowListRows;
		if (iNewPos < 0)
			iNewPos = 0;

		if (iNewPos != g_pRollSetMemberVars->g_iSetRowListPos)
		{
			g_pRollSetMemberVars->g_iSetRowListPos = iNewPos;
			DrawSetRowList();
		}
	}

	iScrollSize = g_pRollSetMemberVars->g_iResultRowCurrentSize - g_pRollSetMemberVars->g_iSetRowListRows;
	if (iScrollSize < 0)
		iScrollSize = 0;

	pScroll = FrmGetObjectPtr(pForm, FrmGetObjectIndex(pForm, IDC_RESULTS_SCROLL));
	SclSetScrollBar (pScroll, g_pRollSetMemberVars->g_iSetRowListPos, 0, iScrollSize, g_pRollSetMemberVars->g_iSetRowListRows);
}
