#include "StdInc.h"

//Boolean g_bShowStopBugging;

// Funcs
Boolean InfoModalProc(EventPtr event);
void DrawInfoModal ();

void UpdateScrollBar (FormPtr pForm);
void ScrollLines (FormPtr pForm, Int16 iLines, Boolean bRedraw);
void ShowControl (FormPtr pForm, UInt16 wId, Boolean bShow);

void DoInfoModal (Char *pTitle, Char *pInfo, Boolean bShowStopBugging, Boolean *pStopBugging)
{
	FormPtr pForm, pOldForm;

	pOldForm = FrmGetActiveForm();
	if (pForm = FrmInitForm(IDF_INFO))
	{
		FieldPtr pField;
		Char *pOldTitle;

		// Set the info text
		if (pTitle)
		{
			pOldTitle = (Char*)FrmGetTitle(pForm);
			FrmSetTitle(pForm, pTitle);
		}

		// Update the scroll bar with the new text.
		if (pInfo)
		{
			SetField (pForm, IDC_INFO_FIELD, StrLen(pInfo), pInfo);
			UpdateScrollBar(pForm);
		}

		// Setup the check box.
		SetCheck(pForm, IDC_INFO_CHECK, *pStopBugging);

		// Show the stop bugging me message.
//		g_bShowStopBugging = bShowStopBugging;
		ShowControl(pForm, IDC_INFO_CHECK, bShowStopBugging);

		// Pre form stuff.
		FrmSetActiveForm(pForm);
		FrmDrawForm(pForm);

		// Do the InfoModal.
		DrawInfoModal();

		// Show the dialog.
		FrmSetEventHandler(pForm, (FormEventHandlerPtr) InfoModalProc);
		FrmDoDialog(pForm);

		// Reset the window title.
		if (pTitle)
		{
			FrmSetTitle(pForm, pOldTitle);
		}

		// Setup the check box.
		*pStopBugging = GetCheck(pForm, IDC_INFO_CHECK);

		// We now return to our other window.
		if (pOldForm)
			FrmSetActiveForm(pOldForm);
		FrmDeleteForm(pForm);
	}
}

Boolean InfoModalProc (EventPtr event)
{
	FormPtr pForm = FrmGetActiveForm();
	Boolean bHandled = false;

    switch (event->eType) 
    {
//	case fldChangedEvent:
//	{
//		UpdateScrollBar(pForm);
//		bHandled = true;
//		break;
//	}

	case ctlSelectEvent:  // A control button was pressed and released.
	{
		bHandled = true;
		switch (event->data.ctlEnter.controlID)
		{
		case IDC_OK:
			bHandled = false;
			break;
		default:;
		}
		break;
	}

//	case ctlRepeatEvent:  // A control button was pressed and released.
//	{
//		bHandled = true;
//		switch (event->data.ctlEnter.controlID)
//		{
//		default:;
//		}
//		break;
//	}
//
//	case menuEvent:  // A control button was pressed and released.
//	{
//		bHandled = true;
//		switch (event->data.menu.itemID)
//		{
//		default:;
//		}
//		break;
//	}
//
//	case keyDownEvent:  // A control button was pressed and released.
//	{
//		bHandled = true;
//		switch (event->data.keyDown.chr)
//		{
//		default:;
//		}
//		break;
//	}
//
//	case penDownEvent:  // A control button was pressed and released.
//	{
//		bHandled = false;
//		break;
//	}

	case sclRepeatEvent:  // A control button was pressed and released.
	{
		switch (event->data.sclRepeat.scrollBarID)
		{
		case IDC_INFO_SCROLL:
			ScrollLines(pForm, event->data.sclRepeat.newValue - event->data.sclRepeat.value, false);
			break;
		default:;
		}
		break;
	}

//	case tblSelectEvent:  // A control button was pressed and released.
//	{
//		bHandled = true;
//		event->data.tblSelect.pTable;
//		event->data.tblSelect.row;
//		switch (event->data.keyDown.chr)
//		{
//		default:;
//		}
//		break;
//	}

	default:
		bHandled = false;
	}

	return bHandled;
}

void DrawInfoModal ()
{
}

void UpdateScrollBar (FormPtr pForm)
{
	ScrollBarPtr pScroll;
	FieldPtr pField;
	UInt16 wCurrentPos;
	UInt16 wTextHeight;
	UInt16 wFieldHeight;
	UInt16 wMaxValue;

	pField = FrmGetObjectPtr(pForm, FrmGetObjectIndex(pForm, IDC_INFO_FIELD));
	pScroll = FrmGetObjectPtr(pForm, FrmGetObjectIndex(pForm, IDC_INFO_SCROLL));

	FldGetScrollValues(pField, &wCurrentPos, &wTextHeight, &wFieldHeight);

	if (wTextHeight > wFieldHeight)
	{
		wMaxValue = wTextHeight - wFieldHeight;
	}
	else if (wCurrentPos)
	{
		wMaxValue = wCurrentPos;
	}
	else
	{
		wMaxValue = 0;
	}
	SclSetScrollBar(pScroll, wCurrentPos, 0, wMaxValue, wFieldHeight - 1);
}

void ScrollLines (FormPtr pForm, Int16 iLines, Boolean bRedraw)
{
	ScrollBarPtr pScroll;
	FieldPtr pField;
	UInt16 wCurrentPos;
	UInt16 wMinValue;
	UInt16 wMaxValue;
	UInt16 wPageSize;

	pField = FrmGetObjectPtr(pForm, FrmGetObjectIndex(pForm, IDC_INFO_FIELD));
	pScroll = FrmGetObjectPtr(pForm, FrmGetObjectIndex(pForm, IDC_INFO_SCROLL));

	if (iLines < 0)
	{
		FldScrollField(pField, -iLines, winUp);
	}
	else
	{
		FldScrollField(pField, iLines, winDown);
	}

//	SclGetScrollBar(pScroll, &wCurrentPos, &wMinValue, &wMaxValue, &wPageSize);
//	ShowControl(pForm, IDC_INFO_CHECK, ((wCurrentPos == wMaxValue) && (g_bShowStopBugging == true)));
}

void ShowControl (FormPtr pForm, UInt16 wId, Boolean bShow)
{
	UInt16 wIndex;

	wIndex = FrmGetObjectIndex(pForm, wId);
	if (bShow)
	{
		FrmShowObject(pForm, wIndex);
	}
	else
	{
		FrmHideObject(pForm, wIndex);
	}
}
